<?php
/**
 * Opencart Gestitrans Shipping Integration module.
 * 
 * Thanks to the wide network of transport companies who we work with, 
 * we can create a personalized proposal for your company, proposing the 
 * best transport company/ies for you to work with in order to optimize 
 * your shipping and reduce your cost.
 * 
 * You must take an agreement with www.gestitrans.com and get a username 
 * and a password from them to make possible to use theese shipping services.
 * 
 * *****************************************************************************
 * 
 * Gracias a la amplia red de empresas de transporte con las que trabajamos, 
 * podemos realizar un estudio personalizado para su empresa, proponindole la 
 * relacin de empresas de transporte que optimicen sus envos y abaraten sus 
 * costes.
 * 
 * Antes de empezar a utilizar los servicios de www.gestitrans.com, debe ponerse 
 * en contacto con gestitrans.com y recibir su nombre de usuario y contrasea 
 * para poder operar en el sistema.
 *  
 * @version 1.0
 * @copyright Garraiotech S.L. 2013
 * @author Ibermatica S.A., 2013
 *
 */
class ControllerShippingGestitrans extends Controller {
	
	const DES_COUNTRY_LIST_URL = "http://gestitrans.ibermatica.com/service/rest/integration/countryList";
	const PRO_COUNTRY_LIST_URL = "https://www.gestitrans.com/service/rest/integration/countryList";
	
	const DES_ADDRESS_SERVICE_URL = "http://gestitrans.ibermatica.com/service/rest/integration/address";
	const PRO_ADDRESS_SERVICE_URL = "https://www.gestitrans.com/service/rest/integration/address";
	
	const DES_USER_VALIDATION_SERVICE_URL = "http://gestitrans.ibermatica.com/service/rest/integration/validateUser";//customer/userValidationService.php";
	const PRO_USER_VALIDATION_SERVICE_URL = "https://www.gestitrans.com/service/rest/integration/validateUser";
	
	const DES_AVG_RATE_SERVICE_URL = "http://gestitrans.ibermatica.com/service/rest/integration/avgPrice";
	const PRO_AVG_RATE_SERVICE_URL = "https://www.gestitrans.com/service/rest/integration/avgPrice";
	
	const DES_LOCATION_VALIDATION_SERVICE_URL = "http://gestitrans.ibermatica.com/service/rest/integration/validateLocation";
	const PRO_LOCATION_VALIDATION_SERVICE_URL = "https://www.gestitrans.com/service/rest/integration/validateLocation";
	
	private $debugMode = true;
	
	private $test = false;
	
	private $error = array(); 
	
	public function index() {
		$this->load->language('shipping/gestitrans');
			
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('gestitrans', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['info_gestitrans_heading'] = $this->language->get('info_gestitrans_heading');
		$this->data['info_gestitrans_body_1'] = $this->language->get('info_gestitrans_body_1');
		$this->data['info_gestitrans_body_2'] = $this->language->get('info_gestitrans_body_2');
		$this->data['info_gestitrans_body_3'] = $this->language->get('info_gestitrans_body_3');
		
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');		
		$this->data['text_select_all'] = $this->language->get('text_select_all');
		$this->data['text_unselect_all'] = $this->language->get('text_unselect_all');		
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		
		$this->data['text_ups'] = $this->language->get('text_ups');
		$this->data['text_gls'] = $this->language->get('text_gls');
		$this->data['text_tourline'] = $this->language->get('text_tourline');
		$this->data['text_fedex'] = $this->language->get('text_fedex');
		$this->data['text_tnt'] = $this->language->get('text_tnt'); 
		$this->data['text_lenght'] = $this->language->get('text_lenght');
		$this->data['text_width']  = $this->language->get('text_width');
		$this->data['text_height'] = $this->language->get('text_height');
		$this->data['text_items_per_package'] = $this->language->get('text_items_per_package');
		$this->data['text_username'] = $this->language->get('text_username');
		$this->data['text_password'] = $this->language->get('text_password');
		$this->data['text_choose_country'] = $this->language->get('text_choose_country');
		$this->data['text_city'] = $this->language->get('text_city');
		$this->data['text_state'] = $this->language->get('text_state');
		$this->data['text_zip'] = $this->language->get('text_zip');
		$this->data['text_address'] = $this->language->get('text_address');
		$this->data['text_choose_country_dial_code'] = $this->language->get('text_choose_country_dial_code');
		$this->data['text_phone_number'] = $this->language->get('text_phone_number');
		
		$this->data['entry_username'] = $this->language->get('entry_username');
		$this->data['entry_password'] = $this->language->get('entry_password');
		$this->data['entry_use_alternative_name'] = $this->language->get('entry_use_alternative_name');
		$this->data['entry_alternative_name'] = $this->language->get('entry_alternative_name');
		$this->data['entry_pickup'] = $this->language->get('entry_pickup');
		$this->data['entry_alternative_origin_address'] = $this->language->get('entry_alternative_origin_address');
		$this->data['entry_city'] = $this->language->get('entry_city');
		$this->data['entry_state'] = $this->language->get('entry_state');
		$this->data['entry_country'] = $this->language->get('entry_country');
		$this->data['entry_postcode'] = $this->language->get('entry_postcode');
		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['entry_quote_type'] = $this->language->get('entry_quote_type');
		$this->data['entry_display_weight'] = $this->language->get('entry_display_weight');
		$this->data['entry_weight_class'] = $this->language->get('entry_weight_class');
		$this->data['entry_length_class'] = $this->language->get('entry_length_class');
		$this->data['entry_length_for_dimensions'] = $this->language->get('entry_length_for_dimensions');
		$this->data['entry_use_item_dimensions'] = $this->language->get('entry_use_item_dimensions');
		$this->data['entry_dimension'] = $this->language->get('entry_dimension');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_debug'] = $this->language->get('entry_debug');
		$this->data['entry_address'] = $this->language->get('entry_address');
		$this->data['entry_phone_number'] = $this->language->get('entry_phone_number');
		$this->data['entry_number_of_items_per_package'] = $this->language->get('entry_number_of_items_per_package');
		$this->data['entry_providers'] = $this->language->get('entry_providers');
		$this->data['entry_auto_ship_configuration'] = $this->language->get('entry_auto_ship_configuration');
		$this->data['entry_default_price_if_no_results'] = $this->language->get('entry_default_price_if_no_results');
		$this->data['entry_terms_and_conds'] = $this->language->get('entry_terms_and_conds');
		$this->data['entry_free_shipping'] = $this->language->get('entry_free_shipping');
		$this->data['entry_free_shipping_price_text1'] = $this->language->get('entry_free_shipping_price_text1');
		$this->data['entry_free_shipping_price_text2'] = $this->language->get('entry_free_shipping_price_text2');
		$this->data['entry_fixed_shipping'] = $this->language->get('entry_fixed_shipping');
		$this->data['entry_fixed_shipping_price_text1'] = $this->language->get('entry_fixed_shipping_price_text1');
		//
		
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_ver_password'] = $this->language->get('button_ver_password');
		$this->data['button_ocultar_password'] = $this->language->get('button_ocultar_password');
		
		/*
		 * Control de errores
		 * Begin
		 */
		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['username'])) {
			$this->data['error_username'] = $this->error['username'];
		} else {
			$this->data['error_username'] = '';
		}

		if (isset($this->error['password'])) {
			$this->data['error_password'] = $this->error['password'];
		} else {
			$this->data['error_password'] = '';
		}
		
		if (isset($this->error['use_alternative_name'])) {
			$this->data['error_use_alternative_name'] = $this->error['use_alternative_name'];
		} else {
			$this->data['error_use_alternative_name'] = '';
		}
		
		/*
		 * La direccion de origen la obtenemos desde Gestitrans en cuanto el usuario introduzca su
		 * usuario y password, a no ser que est activado el check de Usar direccin de origen alternativa.
		 */ 
		if (isset($this->error['alternative_origin_address'])) {
			$this->data['error_alternative_origin_address'] = $this->error['alternative_origin_address'];
		} else {
			$this->data['error_alternative_origin_address'] = '';
		}
		
		if (isset($this->error['country'])) {
			$this->data['error_country'] = $this->error['country'];
		} else {
			$this->data['error_country'] = '';
		}
		
		if (isset($this->error['postalCode_invalid'])) {
			$this->data['error_postalCode_invalid'] = $this->error['postalCode_invalid'];
		} else {
			$this->data['error_postalCode_invalid'] = '';
		}
		
		if (isset($this->error['city_invalid'])) {
			$this->data['error_city_invalid'] = $this->error['city_invalid'];
		} else {
			$this->data['error_city_invalid'] = '';
		}
		
		if (isset($this->error['city'])) {
			$this->data['error_city'] = $this->error['city'];
		} else {
			$this->data['error_city'] = '';
		}

		if (isset($this->error['state'])) {
			$this->data['error_state'] = $this->error['state'];
		} else {
			$this->data['error_state'] = '';
		}
		
		if (isset($this->error['zip'])) {
			$this->data['error_zip'] = $this->error['zip'];
		} else {
			$this->data['error_zip'] = '';
		}
		
		if (isset($this->error['address'])) {
			$this->data['error_address'] = $this->error['address'];
		} else {
			$this->data['error_address'] = '';
		}
		
		if (isset($this->error['phone'])) {
			$this->data['error_phone'] = $this->error['phone'];
		} else {
			$this->data['error_phone'] = '';
		}
		/* */

		if (isset($this->error['dimension'])) {
			$this->data['error_dimension'] = $this->error['dimension'];
		} else {
			$this->data['error_dimension'] = '';
		}
		
		if (isset($this->error['dimension_not_numeric'])) {
			$this->data['error_dimension_not_numeric'] = $this->error['dimension_not_numeric'];
		} else {
			$this->data['error_dimension_not_numeric'] = '';
		}
		
		if (isset($this->error['free_shipping_price'])) {
			$this->data['error_free_shipping_price'] = $this->error['free_shipping_price'];
		} else {
			$this->data['error_free_shipping_price'] = '';
		}
		
		if (isset($this->error['free_shipping_price_not_numeric'])) {
			$this->data['error_free_shipping_price_not_numeric'] = $this->error['free_shipping_price_not_numeric'];
		} else {
			$this->data['error_free_shipping_price_not_numeric'] = '';
		}
		
		if (isset($this->error['fixed_shipping_price'])) {
			$this->data['error_fixed_shipping_price'] = $this->error['fixed_shipping_price'];
		} else {
			$this->data['error_fixed_shipping_price'] = '';
		}
		
		if (isset($this->error['fixed_shipping_price_not_numeric'])) {
			$this->data['error_fixed_shipping_price_not_numeric'] = $this->error['fixed_shipping_price_not_numeric'];
		} else {
			$this->data['error_fixed_shipping_price_not_numeric'] = '';
		}
		
		if (isset($this->error['number_items_per_package'])) {
			$this->data['error_items_per_package'] = $this->error['number_items_per_package'];
		} else {
			$this->data['error_items_per_package'] = '';
		}
		
		if(isset($this->error['one_provider_at_least_required'])){
			$this->data['error_one_provider_at_least_required'] = $this->error['one_provider_at_least_required'];
		}else{
			$this->data['error_one_provider_at_least_required'] = '';
		}
		
		if (isset($this->error['default_price_if_no_results_required'])) {
			$this->data['error_default_price_if_no_results'] = $this->error['default_price_if_no_results_required'];
		} else {
			$this->data['error_default_price_if_no_results'] = '';
		}
		
		if(isset($this->error['must_accept_terms_and_conds'])){
			$this->data['error_gestitrans_terms_and_conds'] = $this->error['must_accept_terms_and_conds'];
		} else {
			$this->data['error_gestitrans_terms_and_conds'] = '';
		}
		/*
		 * Control de errores
		 * End
		 */
		
		/*
		 * Datos de la pgina
		 * Begin
		 */
		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/gestitrans', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = $this->url->link('shipping/gestitrans', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');
		
		if(!$this->config->get('gestitrans_test'))
			$this->test = true;		
		
		if (isset($this->request->post['gestitrans_username'])) {
			$this->data['gestitrans_username'] = $this->request->post['gestitrans_username'];
		} else {
			$this->data['gestitrans_username'] = $this->config->get('gestitrans_username');
		}
		
		if (isset($this->request->post['gestitrans_password'])) {
			$this->data['gestitrans_password'] = $this->request->post['gestitrans_password'];
		} else {
			$this->data['gestitrans_password'] = $this->config->get('gestitrans_password');
		}
		
		if (isset($this->request->post['gestitrans_use_alternative_name'])) {
			$this->data['gestitrans_use_alternative_name'] = $this->request->post['gestitrans_use_alternative_name'];
		} else {
			$this->data['gestitrans_use_alternative_name'] = $this->config->get('gestitrans_use_alternative_name');
		}
		
		if (isset($this->request->post['gestitrans_alternative_name'])) {
			$this->data['gestitrans_alternative_name'] = $this->request->post['gestitrans_alternative_name'];
		} else {
			$this->data['gestitrans_alternative_name'] = $this->config->get('gestitrans_alternative_name');
		}
		
		if (isset($this->request->post['gestitrans_pickup'])) {
			$this->data['gestitrans_pickup'] = $this->request->post['gestitrans_pickup'];
		} else {
			$this->data['gestitrans_pickup'] = $this->config->get('gestitrans_pickup');
		}
		
		/*
		 * Gestin directa de los campos y no desde gestitrans
		 */
		if (isset($this->request->post['gestitrans_country_origin'])) {
			$this->data['gestitrans_country_origin'] = $this->request->post['gestitrans_country_origin'];
		} else {
			$this->data['gestitrans_country_origin'] = $this->config->get('gestitrans_country_origin');
		}
		
		if (isset($this->request->post['gestitrans_city_origin'])) {
			$this->data['gestitrans_city_origin'] = $this->request->post['gestitrans_city_origin'];
		} else {
			$this->data['gestitrans_city_origin'] = $this->config->get('gestitrans_city_origin');
		}
		
		if (isset($this->request->post['gestitrans_state_origin'])) {
			$this->data['gestitrans_state_origin'] = $this->request->post['gestitrans_state_origin'];
		} else {
			$this->data['gestitrans_state_origin'] = $this->config->get('gestitrans_state_origin');
		}

		if (isset($this->request->post['gestitrans_zip_origin'])) {
			$this->data['gestitrans_zip_origin'] = $this->request->post['gestitrans_zip_origin'];
		} else {
			$this->data['gestitrans_zip_origin'] = $this->config->get('gestitrans_zip_origin');
		}
		
		if (isset($this->request->post['gestitrans_street_origin'])) {
			$this->data['gestitrans_street_origin'] = $this->request->post['gestitrans_street_origin'];
		} else {
			$this->data['gestitrans_street_origin'] = $this->config->get('gestitrans_street_origin');
		}
		
		if (isset($this->request->post['gestitrans_street2_origin'])) {
			$this->data['gestitrans_street2_origin'] = $this->request->post['gestitrans_street2_origin'];
		} else {
			$this->data['gestitrans_street2_origin'] = $this->config->get('gestitrans_street2_origin');
		}
		
		if (isset($this->request->post['gestitrans_phone_number'])) {
			$this->data['gestitrans_phone_number'] = $this->request->post['gestitrans_phone_number'];
		} else {
			$this->data['gestitrans_phone_number'] = $this->config->get('gestitrans_phone_number');
		}
		
		if (isset($this->request->post['gestitrans_phone_dialcode'])) {
			$this->data['gestitrans_phone_dialcode'] = $this->request->post['gestitrans_phone_dialcode'];
		} else {
			$this->data['gestitrans_phone_dialcode'] = $this->config->get('gestitrans_phone_dialcode');
		}
		
		$gestitrans_test = $this->config->get("gestitrans_test");
		if(isset($gestitrans_test) && $gestitrans_test == 1){
			$this->test = true;
		}
		
		$this->load->model('localisation/country');
		$this->data['countries'] = $this->model_localisation_country->getCountries();
		
		$this->data['gestitrans_origin_country'] = array();
		$country_origin_list = $this->getCountryList($this->test);
		
		$userName = $this->config->get('gestitrans_username');
		$password = $this->config->get('gestitrans_password');
		
		if (isset($this->request->post['gestitrans_alternative_origin_address'])) {
			$this->data['gestitrans_alternative_origin_address'] = $this->request->post['gestitrans_alternative_origin_address'];
		} else {
			$this->data['gestitrans_alternative_origin_address'] = $this->config->get('gestitrans_alternative_origin_address');
		}
		
		$alternative_origin_address = $this->data['gestitrans_alternative_origin_address'];
		
		if(isset($userName) && isset($password)){
			
			if (isset($alternative_origin_address) && ($alternative_origin_address==1)) {
			
				/*echo $this->data['gestitrans_country_origin'];
				$this->data['gestitrans_country_origin'] 	= $this->data['gestitrans_country_origin'];
				$this->data['gestitrans_phone_dialcode'] 	= $this->config->get('gestitrans_phone_dialcode');
				$this->data['gestitrans_country_origin_name'] 	= $this->config->get('gestitrans_country_origin_name');
				$this->data['gestitrans_city_origin'] 		= $this->config->get('gestitrans_city_origin');
				$this->data['gestitrans_zip_origin'] 		= $this->config->get('gestitrans_zip_origin');
				$this->data['gestitrans_state_origin']		= $this->config->get('gestitrans_state_origin');
				$this->data['gestitrans_street_origin']		= $this->config->get('gestitrans_street_origin');
				$this->data['gestitrans_phone_number']		= $this->config->get('gestitrans_phone_number');*/
				$this->data['gestitrans_quote_type']		= $this->config->get('gestitrans_quote_type');
				$this->data['gestitrans_default_price_if_no_results'] = $this->getAvgDefaultPrice($userName, $password, $this->test);
			}else{
			
				$jsonAddress = $this->getUserAddress($userName, $password, $this->test);
				foreach($country_origin_list as $country){
					if($country->countryISO == $jsonAddress->country){
						$this->data['gestitrans_country_origin'] = $country->id;
						$this->data['gestitrans_phone_dialcode'] = $country->dialCode;
						$this->data['gestitrans_country_origin_name'] = $country->countryName;
					}
				}
				//$this->data['gestitrans_country_origin'] 	= $jsonAddress->country;
				$this->data['gestitrans_city_origin'] 		= $jsonAddress->city;
				$this->data['gestitrans_zip_origin'] 		= $jsonAddress->postalCode;
				$this->data['gestitrans_state_origin']		= $jsonAddress->state;
				$this->data['gestitrans_street_origin']		= $jsonAddress->address;
				$this->data['gestitrans_phone_number']		= $jsonAddress->phoneNumber;
				//$this->data['gestitrans_phone_dialcode']	= $jsonAddress->country;
				$this->data['gestitrans_quote_type']		= $jsonAddress->zoneType;
				/*if ($jsonAddress->mainZoneType=='urban'){
					$this->data['gestitrans_quote_type']	= $this->language->get('text_business_urban');
				}
				else{
					$this->data['gestitrans_quote_type']	= $this->language->get('text_business_industrial');
				}*/
				$this->data['gestitrans_default_price_if_no_results'] = $this->getAvgDefaultPrice($userName, $password, $this->test);
			}
		
			
		}else{
			/*$this->data['gestitrans_country_origin'] 	= "";
			$this->data['gestitrans_phone_dialcode'] 	= "";
			$this->data['gestitrans_country_origin_name'] = "";
			//$this->data['gestitrans_country_origin'] 	= "";
			$this->data['gestitrans_city_origin'] 		= "";
			$this->data['gestitrans_zip_origin'] 		= "";
			$this->data['gestitrans_state_origin']		= "";
			$this->data['gestitrans_street_origin']		= "";
			$this->data['gestitrans_phone_number']		= "";
			//$this->data['gestitrans_phone_dialcode']	= "";
			$this->data['gestitrans_quote_type']		= "";
			$this->data['gestitrans_quote_type_name']	= "";
			$this->data['gestitrans_default_price_if_no_results'] = 0.0;*/
			$this->data['gestitrans_quote_type']		= "";
		}
		
		if (isset($this->request->post['gestitrans_display_weight'])) {
			$this->data['gestitrans_display_weight'] = $this->request->post['gestitrans_display_weight'];
		} else {
			$this->data['gestitrans_display_weight'] = $this->config->get('gestitrans_display_weight');
		}
		
		
		
		if (isset($this->request->post['gestitrans_use_item_dimensions'])) {
			$this->data['gestitrans_use_item_dimensions'] = $this->request->post['gestitrans_use_item_dimensions'];
		} else {
			$this->data['gestitrans_use_item_dimensions'] = $this->config->get('gestitrans_use_item_dimensions');
		}
		
		if (isset($this->request->post['gestitrans_length'])) {
			$this->data['gestitrans_length'] = $this->request->post['gestitrans_length'];
		} else {
			$this->data['gestitrans_length'] = $this->config->get('gestitrans_length');
		}
		
		if (isset($this->request->post['gestitrans_width'])) {
			$this->data['gestitrans_width'] = $this->request->post['gestitrans_width'];
		} else {
			$this->data['gestitrans_width'] = $this->config->get('gestitrans_width');
		}		
		
		if (isset($this->request->post['gestitrans_height'])) {
			$this->data['gestitrans_height'] = $this->request->post['gestitrans_height'];
		} else {
			$this->data['gestitrans_height'] = $this->config->get('gestitrans_height');
		}
		
		if (isset($this->request->post['gestitrans_free_shipping_price'])) {
			$this->data['gestitrans_free_shipping_price'] = $this->request->post['gestitrans_free_shipping_price'];
		} else {
			$this->data['gestitrans_free_shipping_price'] = $this->config->get('gestitrans_free_shipping_price');
		}
		
		if (isset($this->request->post['gestitrans_fixed_shipping_price'])) {
			$this->data['gestitrans_fixed_shipping_price'] = $this->request->post['gestitrans_fixed_shipping_price'];
		} else {
			$this->data['gestitrans_fixed_shipping_price'] = $this->config->get('gestitrans_fixed_shipping_price');
		}
		
		if (isset($this->request->post['gestitrans_number_items_per_package'])) {
			$this->data['gestitrans_number_items_per_package'] = $this->request->post['gestitrans_number_items_per_package'];
		} else {
			$this->data['gestitrans_number_items_per_package'] = $this->config->get('gestitrans_number_items_per_package');
		}		
		
		/*
		if (isset($this->request->post['gestitrans_ups_selected'])) {
			$this->data['gestitrans_ups_selected'] = $this->request->post['gestitrans_ups_selected'];
		} else {
			$this->data['gestitrans_ups_selected'] = $this->config->get('gestitrans_ups_selected');
		}
		
		if (isset($this->request->post['gestitrans_gls_selected'])) {
			$this->data['gestitrans_gls_selected'] = $this->request->post['gestitrans_gls_selected'];
		} else {
			$this->data['gestitrans_gls_selected'] = $this->config->get('gestitrans_gls_selected');
		}
		
		if (isset($this->request->post['gestitrans_tourline_selected'])) {
			$this->data['gestitrans_tourline_selected'] = $this->request->post['gestitrans_tourline_selected'];
		} else {
			$this->data['gestitrans_tourline_selected'] = $this->config->get('gestitrans_tourline_selected');
		}
		
		if (isset($this->request->post['gestitrans_fedex_selected'])) {
			$this->data['gestitrans_fedex_selected'] = $this->request->post['gestitrans_fedex_selected'];
		} else {
			$this->data['gestitrans_fedex_selected'] = $this->config->get('gestitrans_fedex_selected');
		}
		
		if (isset($this->request->post['gestitrans_tnt_selected'])) {
			$this->data['gestitrans_tnt_selected'] = $this->request->post['gestitrans_tnt_selected'];
		} else {
			$this->data['gestitrans_tnt_selected'] = $this->config->get('gestitrans_tnt_selected');
		}
		*/
		
		/*if (isset($this->request->post['gestitrans_default_price_if_no_results'])) {
			$this->data['gestitrans_default_price_if_no_results'] = $this->request->post['gestitrans_default_price_if_no_results'];
		} else {
			$this->data['gestitrans_default_price_if_no_results'] = $this->config->get('gestitrans_default_price_if_no_results');
		}*/		
		
		if (isset($this->request->post['gestitrans_geo_zone_id'])) {
			$this->data['gestitrans_geo_zone_id'] = $this->request->post['gestitrans_geo_zone_id'];
		} else {
			$this->data['gestitrans_geo_zone_id'] = $this->config->get('gestitrans_geo_zone_id');
		}
		
		if (isset($this->request->post['gestitrans_status'])) {
			$this->data['gestitrans_status'] = $this->request->post['gestitrans_status'];
		} else {
			$this->data['gestitrans_status'] = $this->config->get('gestitrans_status');
		}
		
		if (isset($this->request->post['gestitrans_sort_order'])) {
			$this->data['gestitrans_sort_order'] = $this->request->post['gestitrans_sort_order'];
		} else {
			$this->data['gestitrans_sort_order'] = $this->config->get('gestitrans_sort_order');
		}
		
		if (isset($this->request->post['gestitrans_test'])) {
			$this->data['gestitrans_test'] = $this->request->post['gestitrans_test'];
		} else {
			$this->data['gestitrans_test'] = $this->config->get('gestitrans_test');
		}
		
		if (isset($this->request->post['gestitrans_debug'])) {
			$this->data['gestitrans_debug'] = $this->request->post['gestitrans_debug'];
		} else {
			$this->data['gestitrans_debug'] = $this->config->get('gestitrans_debug');
		}
		$this->debugMode = ($this->data['gestitrans_debug']==1);  
		
		if (isset($this->request->post['gestitrans_terms_and_conds'])) {
			$this->data['gestitrans_terms_and_conds'] = $this->request->post['gestitrans_terms_and_conds'];
		} else {
			$this->data['gestitrans_terms_and_conds'] = $this->config->get('gestitrans_terms_and_conds');
		}
		
		if (isset($this->request->post['gestitrans_free_shipping'])) {
			$this->data['gestitrans_free_shipping'] = $this->request->post['gestitrans_free_shipping'];
		} else {
			$this->data['gestitrans_free_shipping'] = $this->config->get('gestitrans_free_shipping');
		}
		
		if (isset($this->request->post['gestitrans_fixed_shipping'])) {
			$this->data['gestitrans_fixed_shipping'] = $this->request->post['gestitrans_fixed_shipping'];
		} else {
			$this->data['gestitrans_fixed_shipping'] = $this->config->get('gestitrans_fixed_shipping');
		}
		
		/*echo $this->data['gestitrans_quote_type'];
		echo '--->'.$this->request->post['gestitrans_quote_type'].'<---';
		if (isset($this->request->post['gestitrans_quote_type'])) {
			$this->data['gestitrans_quote_type'] = $this->request->post['gestitrans_quote_type'];
		} else {
			$this->data['gestitrans_quote_type'] = $this->config->get('gestitrans_quote_type');
		}
		echo '-->'.$this->data['gestitrans_quote_type'].'<--';*/
		
		if (isset($this->request->post['gestitrans_weight_class_id'])) {
			$this->data['gestitrans_weight_class_id'] = $this->request->post['gestitrans_weight_class_id'];
		} else {
			$this->data['gestitrans_weight_class_id'] = $this->config->get('gestitrans_weight_class_id');
		}
		
		if (isset($this->request->post['gestitrans_length_class_id'])) {
			$this->data['gestitrans_length_class_id'] = $this->request->post['gestitrans_length_class_id'];
		} else {
			$this->data['gestitrans_length_class_id'] = $this->config->get('gestitrans_length_class_id');
		}
		
		$this->load->model('localisation/weight_class');
		
		$this->data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();
		$found = false;
		$weights = array();
		foreach($this->data['weight_classes'] as $weight){
			if($weight['value'] == 1.0){
				$found = true;
				$weights[] = $weight;
			}
		}
		if($found)
			$this->data['weight_classes'] = $weights; 
		
		$this->load->model('localisation/length_class');
		
		$this->data['length_classes'] = $this->model_localisation_length_class->getLengthClasses();
		$found = false;
		$lengths = array();
		foreach($this->data['length_classes'] as $lenght){
			if($lenght['value'] == 1.0){
				$found = true;
				$lengths[] = $lenght;
			}
		}
		if($found)
			$this->data['length_classes'] = $lengths; 
				
		// Campos de infoenvia:
		
		$this->data['delay_for_shipping'] = array();
		  
		$this->data['delay_for_shipping'][] = array(
			'value' => '0',
			'text'  => $this->language->get('text_delay_for_shipping_same_day')
		);
		
		$this->data['delay_for_shipping'][] = array(
			'value' => '1',
			'text'  => $this->language->get('text_delay_for_shipping_+1')
		);
		
		$this->data['delay_for_shipping'][] = array(
			'value' => '2',
			'text'  => $this->language->get('text_delay_for_shipping_+2')
		);
		
		$this->data['delay_for_shipping'][] = array(
			'value' => '3',
			'text'  => $this->language->get('text_delay_for_shipping_+3')
		);

		$this->data['gestitrans_quote_types'] = array();
		  
		$this->data['gestitrans_quote_types'][] = array(
			'value' => 'private_residence',
			'text'  => $this->language->get('text_private_residence')
		);

		$this->data['gestitrans_quote_types'][] = array(
			'value' => 'business_urban',
			'text'  => $this->language->get('text_business_urban')
		);
		
		$this->data['gestitrans_quote_types'][] = array(
			'value' => 'business_industrial',
			'text'  => $this->language->get('text_business_industrial')
		);
		
		foreach ($this->data['gestitrans_quote_types'] as $quote_type){
			if($quote_type['value']==$this->data['gestitrans_quote_type']){
				$this->data['gestitrans_quote_type_name'] = $quote_type['text']; 
			}
		}
		$this->data['gestitrans_origin_country'] = array();
		
		//echo print_r($country_origin_list);
		foreach($this->data['countries'] as $country){
			/*$countryArray = array(
				'value' => $countryItem.id(),
				'text'  => $countryItem.countryName()
			);
			array_push($this->data['infoenvia_origin_country'], $countryArray);*/
			//var_dump($countryItem);
			foreach($country_origin_list as $countryItem){	
				if($country['iso_code_2'] == $countryItem->countryISO){
					$this->data['gestitrans_origin_country'][] = array(
						'value' => $countryItem->id,
						'text'  => $country['name']
					); 
				}
			}
		}
		
		$this->data['gestitrans_country_dialcode_list'] = array();
		//echo print_r($country_origin_list);
		foreach($this->data['countries'] as $country){
			/*$countryArray = array(
				'value' => $countryItem.id(),
				'text'  => $countryItem.countryName()
			);
			array_push($this->data['infoenvia_origin_country'], $countryArray);*/
			//var_dump($countryItem);
			foreach($country_origin_list as $countryItem){	
				if($country['iso_code_2'] == $countryItem->countryISO){
					$this->data['gestitrans_country_dialcode_list'][] = array(
						'value' => $countryItem->dialCode,
						'text'  => $country['name']." (".$countryItem->dialCode.")"
					);
				}
			} 
		}
		
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = array();
		foreach($this->model_localisation_geo_zone->getGeoZones() as $geozone){
			if($geozone['geo_zone_id'] == '0'){
				$this->data['geo_zones'][] = $geozone; 		
			}
		}
		
		$this->data['gestitrans_auto_ship_methods'] = array();
		  
		$this->data['gestitrans_auto_ship_methods'][] = array(
			'value' => 'disabled',
			'text'  => $this->language->get('text_auto_ship_disabled')
		);
		
		$this->data['gestitrans_auto_ship_methods'][] = array(
			'value' => 'enabled_auto',
			'text'  => $this->language->get('text_auto_ship_enabled')
		);
		
		$this->data['gestitrans_auto_ship_methods'][] = array(
			'value' => 'enabled_admin',
			'text'  => $this->language->get('text_auto_ship_admin')
		);
		/*
		 * Datos de la pgina
		 * End
		 */
		
		
		$this->template = 'shipping/gestitrans.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
		
 		$this->response->setOutput($this->render());
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/gestitrans')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		$userInformed = true;		
		if (!$this->request->post['gestitrans_username'] || $this->request->post['gestitrans_username']=="") {
			$this->error['username'] = $this->language->get('error_username');
			$userInformed = false;
		}

		if (!$this->request->post['gestitrans_password'] || $this->request->post['gestitrans_password']=="") {
			$this->error['password'] = $this->language->get('error_password');
			$userInformed = false;
		}
		
		$alternativeOriginInformed = false;
		if (isset($this->request->post['gestitrans_alternative_origin_address'])) {
			$alternativeOriginInformed = true;
		}
		
		// Begin Validate alternative origin address
		if ($alternativeOriginInformed && empty($this->request->post['gestitrans_country_origin'])) {
			$this->error['country'] = $this->language->get('error_country');
		}
		
		if ($alternativeOriginInformed && (empty($this->request->post['gestitrans_city_origin']))) {
			$this->error['city'] = $this->language->get('error_city');
		}
		
		if ($alternativeOriginInformed && empty($this->request->post['gestitrans_zip_origin'])) {
			$this->error['zip'] = $this->language->get('error_zip');
		}
		
		if ($alternativeOriginInformed && empty($this->request->post['gestitrans_street_origin'])) {
			$this->error['address'] = $this->language->get('error_address');
		}
		
		if ($alternativeOriginInformed && empty($this->request->post['gestitrans_phone_number'])) {
			$this->error['phone'] = $this->language->get('error_phone');
		}
		
		if ($alternativeOriginInformed && empty($this->request->post['gestitrans_phone_dialcode'])) {
			$this->error['phone'] = $this->language->get('error_phone_dialcode');
		}

		if (
			$alternativeOriginInformed
			&& ($this->request->post['gestitrans_country_origin']=="120" || $this->request->post['gestitrans_country_origin']=="172")
			&& !$this->request->post['gestitrans_state']) {
			$this->error['state'] = $this->language->get('error_state');
		}
		// End Validate alternative origin address
		
		if (empty($this->request->post['gestitrans_length'])) {
			$this->error['dimension'] = $this->language->get('error_dimension');
		}
		
		if (empty($this->request->post['gestitrans_width'])) {
			$this->error['dimension'] = $this->language->get('error_dimension');
		}
		
		if (empty($this->request->post['gestitrans_height'])) {
			$this->error['dimension'] = $this->language->get('error_dimension');
		}
		
		if (!empty($this->request->post['gestitrans_length']) && (!is_numeric($this->request->post['gestitrans_length']))) {
			$this->error['dimension_not_numeric'] = $this->language->get('error_dimension_not_numeric');
		}
		
		if (!empty($this->request->post['gestitrans_width']) && (!is_numeric($this->request->post['gestitrans_width']))) {
			$this->error['dimension_not_numeric'] = $this->language->get('error_dimension_not_numeric');
		}
		
		if (!empty($this->request->post['gestitrans_height']) && (!is_numeric($this->request->post['gestitrans_height']))) {
			$this->error['dimension_not_numeric'] = $this->language->get('error_dimension_not_numeric');
		}
		
		if (  (isset($this->request->post['gestitrans_free_shipping'])) && ($this->request->post['gestitrans_free_shipping']==1) && empty($this->request->post['gestitrans_free_shipping_price'])) {
			$this->error['free_shipping_price'] = $this->language->get('error_free_shipping_price');
		}
		
		if (  (isset($this->request->post['gestitrans_free_shipping'])) && ($this->request->post['gestitrans_free_shipping']==1) && !empty($this->request->post['gestitrans_free_shipping_price']) && !is_numeric($this->request->post['gestitrans_free_shipping_price']) ) {
			$this->error['free_shipping_price_not_numeric'] = $this->language->get('error_free_shipping_price_not_numeric');
		}
		
		if ( (isset($this->request->post['gestitrans_fixed_shipping'])) &&  ($this->request->post['gestitrans_fixed_shipping']==1) && empty($this->request->post['gestitrans_fixed_shipping_price'])) {
			$this->error['fixed_shipping_price'] = $this->language->get('error_fixed_shipping_price');
		}
		
		if (  (isset($this->request->post['gestitrans_fixed_shipping'])) && ($this->request->post['gestitrans_fixed_shipping']==1) && !empty($this->request->post['gestitrans_fixed_shipping_price']) && !is_numeric($this->request->post['gestitrans_fixed_shipping_price']) ) {
			$this->error['fixed_shipping_price_not_numeric'] = $this->language->get('error_fixed_shipping_price_not_numeric');
		}
		
		if (empty($this->request->post['gestitrans_number_items_per_package'])) {
			//$this->error['number_items_per_package'] = $this->language->get('error_number_items_per_package');
			$this->request->post['gestitrans_number_items_per_package'] = 1;
		}
		
		if (!empty($this->request->post['gestitrans_use_alternative_name']) && empty($this->request->post['gestitrans_alternative_name'])) {
			$this->error['use_alternative_name'] = $this->language->get('error_use_alternative_name');
		}
		
		if (empty($this->request->post['gestitrans_terms_and_conds']) || $this->request->post['gestitrans_terms_and_conds'] != 1) {
			$this->error['must_accept_terms_and_conds'] = $this->language->get('error_must_accept_terms_and_conds');
		}
		
		/*if (!isset($this->request->post['gestitrans_ups_selected']) &&
			!isset($this->request->post['gestitrans_gls_selected']) &&
			!isset($this->request->post['gestitrans_tourline_selected']) &&
			!isset($this->request->post['gestitrans_fedex_selected']) &&
			!isset($this->request->post['gestitrans_tnt_selected'])) {
				
			$this->error['one_provider_at_least_required'] = $this->language->get('error_one_provider_at_list_required');
		}*/
		
		if(!isset($this->request->post['gestitrans_sort_order']) || $this->request->post['gestitrans_sort_order'] != 1){
			$this->request->post['gestitrans_sort_order'] = 1;
		}

		if($this->debugMode)$this->log->write("Test mode = ".$this->request->post['gestitrans_test']);
		if(!isset($this->request->post['gestitrans_test']) || $this->request->post['gestitrans_test'] == 1){
			$this->test = true;
		}
		if($this->debugMode)$this->log->write("Test mode = ".$this->test);
		
		
		$userValid = true;
		if($userInformed){
			$userValidation = $this->getUserValidation($this->request->post['gestitrans_username'], $this->request->post['gestitrans_password'], $this->test);
			if(!isset($userValidation) || !isset($userValidation->globalResult) || $userValidation->globalResult!=00){
				$this->error['username'] = $this->language->get('error_username_password_invalid');
				$this->error['password'] = $this->language->get('error_username_password_invalid');
				$userValid = false;
			}
			if($userValid){
				$this->request->post['gestitrans_default_price_if_no_results'] = $this->getAvgDefaultPrice($this->request->post['gestitrans_username'], $this->request->post['gestitrans_password'], $this->test);
				
				if (isset($this->request->post['gestitrans_alternative_origin_address'])) {
					$this->data['gestitrans_alternative_origin_address'] = $this->request->post['gestitrans_alternative_origin_address'];
				} else {
					$this->data['gestitrans_alternative_origin_address'] = $this->config->get('gestitrans_alternative_origin_address');
				}
				$alternative_origin_address = $this->data['gestitrans_alternative_origin_address'];
				
				if (isset($alternative_origin_address) && ($alternative_origin_address==1)) {
				
					// validacion codigo postal
					$locationValidation = $this->getLocationValidation($this->request->post['gestitrans_username'], $this->request->post['gestitrans_password'], $this->request->post['gestitrans_country_origin'], $this->request->post['gestitrans_zip_origin'], $this->request->post['gestitrans_city_origin'], $this->test);
					if( !isset($locationValidation) || !isset($locationValidation->globalResult) || $locationValidation->globalResult==03 ){
						$this->error['postalCode_invalid'] = $this->language->get('error_postalCode_invalid');
					}
					
					if( !isset($locationValidation) || !isset($locationValidation->globalResult) || $locationValidation->globalResult==05 ){
						$this->error['city_invalid'] = $this->language->get('error_city_invalid').$locationValidation->validCities;
					}
				
				}else{
				
					$userAddress = $this->getUserAddress($this->request->post['gestitrans_username'], $this->request->post['gestitrans_password'], $this->test);
					$country_origin_list = $this->getCountryList($this->test);
					foreach($country_origin_list as $country){
						if($country->countryISO == $userAddress->country){
							$this->request->post['gestitrans_country_origin'] 	= $country->id;
						}
					}
					$this->request->post['gestitrans_city_origin']		= $userAddress->city;
					$this->request->post['gestitrans_zip_origin']		= $userAddress->postalCode;
					$this->request->post['gestitrans_street_origin']	= $userAddress->address;
					$this->request->post['gestitrans_phone_number']		= $userAddress->phoneNumber;
					if($userAddress->state != "")
						$this->request->post['gestitrans_state']		= $userAddress->state;
					$this->request->post['gestitrans_quote_type']		= $userAddress->zoneType; 
				}
			}
		}
		
		/*if (!isset($this->request->post['gestitrans_default_price_if_no_results']) || !is_numeric($this->request->post['gestitrans_default_price_if_no_results'])){
			$this->error['default_price_if_no_results_required'] = $this->language->get('error_default_price_if_no_results_required');
		}*/
				
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
	
	private function getCountryList($test = false){
		if($test)
			$ch = curl_init(ControllerShippingGestitrans::DES_COUNTRY_LIST_URL);
		else
			$ch = curl_init(ControllerShippingGestitrans::PRO_COUNTRY_LIST_URL);
		//echo "url:".ControllerShippingInfoenvia::COUNTRY_LIST_URL;
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
		curl_close($ch);
		$jsonOutput = json_decode($output);
		return $jsonOutput;
	}
	
	private function getUserAddress($userName, $password, $test = true){
		if($test)
			$ch = curl_init(ControllerShippingGestitrans::DES_ADDRESS_SERVICE_URL);
		else
			$ch = curl_init(ControllerShippingGestitrans::PRO_ADDRESS_SERVICE_URL);
			
		//echo "url:".ControllerShippingInfoenvia::COUNTRY_LIST_URL;
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "userName=".$userName."&password=".$password);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
		curl_close($ch);
		//echo $output;
		$jsonOutput = json_decode($output);
		return $jsonOutput;
	}
	
	private function getUserValidation($userName, $password, $test = true){
		if($test)
			$ch = curl_init(ControllerShippingGestitrans::DES_USER_VALIDATION_SERVICE_URL);
		else
			$ch = curl_init(ControllerShippingGestitrans::PRO_USER_VALIDATION_SERVICE_URL);
			
		//echo "url:".ControllerShippingInfoenvia::COUNTRY_LIST_URL;
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "userName=".$userName."&password=".$password);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
		curl_close($ch);
		//echo $output;
		$jsonOutput = json_decode($output);
		return $jsonOutput;
	}
	
	private function getLocationValidation($userName, $password, $country, $postalCode, $city, $test = true){

		if($test)
			$ch = curl_init(ControllerShippingGestitrans::DES_LOCATION_VALIDATION_SERVICE_URL);
		else
			$ch = curl_init(ControllerShippingGestitrans::PRO_LOCATION_VALIDATION_SERVICE_URL);	
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "userName=".$userName."&password=".$password."&country=".$country."&postalCode=".$postalCode."&city=".$city);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
		curl_close($ch);
		$jsonOutput = json_decode($output);
		return $jsonOutput;
	}
	
	private function getAvgDefaultPrice($userName, $password, $test = true){
		if($test)
			$ch = curl_init(ControllerShippingGestitrans::DES_AVG_RATE_SERVICE_URL);
		else
			$ch = curl_init(ControllerShippingGestitrans::PRO_AVG_RATE_SERVICE_URL);
			
		//echo "url:".ControllerShippingInfoenvia::COUNTRY_LIST_URL;
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "user=".$userName."&password=".$password."&portal=GT");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
		curl_close($ch);
		//echo $output;
		$jsonOutput = json_decode($output);
		if(isset($jsonOutput->precioMedio)){
			return round($jsonOutput->precioMedio,2);
		}else{
			return 10.0;	
		}
	}
}
?>