<?php
/**
 * Opencart Gestitrans Shipping Integration module.
 * 
 * Thanks to the wide network of transport companies who we work with, 
 * we can create a personalized proposal for your company, proposing the 
 * best transport company/ies for you to work with in order to optimize 
 * your shipping and reduce your cost.
 * 
 * You must take an agreement with www.gestitrans.com and get a username 
 * and a password from them to make possible to use theese shipping services.
 * 
 * *****************************************************************************
 * 
 * Gracias a la amplia red de empresas de transporte con las que trabajamos, 
 * podemos realizar un estudio personalizado para su empresa, proponindole la 
 * relacin de empresas de transporte que optimicen sus envos y abaraten sus 
 * costes.
 * 
 * Antes de empezar a utilizar los servicios de www.gestitrans.com, debe ponerse 
 * en contacto con gestitrans.com y recibir su nombre de usuario y contrasea 
 * para poder operar en el sistema.
 *  
 * @version 1.0
 * @copyright Garraiotech S.L. 2013
 * @author Ibermatica S.A., 2013
 *
 */
// Heading
$_['heading_title']                = 'Gestitrans';
$_['info_gestitrans_heading']	   = 'Gestitrans Service Information:';
$_['info_gestitrans_body_1']	   = '<a href="https://www.gestitrans.com">Gestitrans.com</a> makes freight shipping fast, easy and price friendly.';
$_['info_gestitrans_body_2']	   = 'You must take an agreement with <a href="https://www.gestitrans.com">gestitrans.com</a> and get a username and a password from them to make possible to use their shipping services.';
$_['info_gestitrans_body_3']	   = 'Thanks to the wide network of transport companies who we work with, we can create a personalized proposal for your company, proposing the best transport company/ies for you to work with in order to optimize your shipping and reduce your cost.';

// Text
$_['text_shipping']                = 'Shipping';
$_['text_success']                 = 'Success: You have modified Gestitrans shipping!';
$_['text_regular_daily_pickup']    = 'Regular Daily Pickup';
$_['text_daily_pickup']            = 'Daily Pickup';
$_['text_customer_counter']        = 'Customer Counter';
$_['text_one_time_pickup']         = 'One Time Pickup';
$_['text_on_call_air_pickup']      = 'On Call Air Pickup';
$_['text_letter_center']           = 'Letter Center';
$_['text_air_service_center']      = 'Air Service Center';
$_['text_package']                 = 'Package';
$_['text_us']                      = 'US Origin';
$_['text_ca']                      = 'Canada Origin';
$_['text_eu']                      = 'European Union Origin';
$_['text_pr']                      = 'Puerto Rico Origin';
$_['text_mx']                      = 'Mexico Origin';
$_['text_other']                   = 'All Other Origins';
$_['text_test']                    = 'Test';
$_['text_production']              = 'Production';	
$_['text_residential']             = 'Residential';
$_['text_commercial']              = 'Commercial';

// Entry
$_['entry_username']               = 'Username:<span class="help">Enter your Gestitrans Services account username.</span>';
$_['entry_password']               = 'Password:<span class="help">Enter your Gestitrans Services account password.</span>';
$_['entry_use_alternative_name']   = 'Use alternative name for results section title:<span class="help">Use an alternative name rather than "Gestitrans".</span>';
$_['entry_alternative_name']       = 'An alternative name for results section title:<span class="help">The alternative name to use in search results list rather than "Gestitrans".</span>';
$_['entry_pickup']                 = 'Delay for shipping in days:<span class="help">Number of days from purchasing the product until it is ready to be pcked up</span>';
$_['entry_packaging']              = 'Packaging Type:<span class="help">What kind of packaging do you use?</span>';
$_['entry_classification']         = 'Customer Classification Code:<span class="help">01 - If you are billing to a UPS account and have a daily UPS pickup, 03 - If you do not have a UPS account or you are billing to a UPS account but do not have a daily pickup, 04 - If you are shipping from a retail outlet (only used when origin is US)</span>';
$_['entry_alternative_origin_address'] = 'Use alternative origin address<br /><span class="help">By default, Gestitrans shipping module gets origin address for your shippings (the address where carriers will attemp to take your packages for shipping) from the address you provided where signing in www.gestitrans.com. However, it is possible to use an altenative address just checking this option and completengs fields below.</span>';
$_['entry_origin']                 = 'Shipping Origin Code:<span class="help">What origin point should be used (this setting affects only what UPS product names are shown to the user)</span>';
//$_['entry_city']                   = 'Origin City:<span class="help">Enter the name of the origin city.</span>';
$_['entry_city']                   = 'Origin City:';
//$_['entry_state']                  = 'Origin State/Province:<span class="help">Enter your origin state/province. Required if country is US/Canada</span>';
$_['entry_state']                  = 'Origin State/Province:';
//$_['entry_country']                = 'Origin Country:<span class="help">Select your origin country.</span>';
$_['entry_country']                = 'Origin Country:';
//$_['entry_postcode']               = 'Origin Zip/Postal Code:<span class="help">Enter your origin zip/postalcode.</span>';
$_['entry_postcode']               = 'Origin Zip/Postal Code:';
$_['entry_test']                   = 'Test Mode:<span class="help">Use this module in Test (YES) or Production mode (NO)?</span>';
$_['entry_quote_type']             = 'Quote Type:<span class="help">Quote for Residential or Commercial Delivery.</span>';
$_['entry_insurance']              = 'Enable Insurance:<span class="help">Enables insurance with product total as the value</span>';
$_['entry_display_weight']         = 'Display Delivery Weight:<br /><span class="help">Do you want to display the shipping weight? (e.g. Delivery Weight : 2.7674 Kg\'s)</span>';
$_['entry_weight_class']           = 'Weight Class:<span class="help">Must be kilograms</span>';
$_['entry_length_class']           = 'Length Class:<span class="help">Must be centimeters</span>';
$_['entry_length_for_dimensions']  = '<span>Must be centimeters</span>';
$_['entry_use_item_dimensions']	   = 'Use individual items dimensions, if are informed:<br /><span class="help">If a item has not its package dimensions informed, average packet size and items per package settings would be used.</span>';
$_['entry_dimension']			   = 'Dimensions (L x W x H):<br /><span class="help">This is assumed to be your average packing box size, if it is not selected to use individual items sizes</span>';
$_['entry_tax_class']              = 'Tax Class:';
$_['entry_default_price_if_no_results'] = 'Default price if no results:<br /><span class="help">If an error occurs during the live price check, this default price value would be shown.</span>';
$_['entry_geo_zone']               = 'Geo Zone:';
$_['entry_status']                 = 'Status:';
$_['entry_sort_order']             = 'Sort Order:';
$_['entry_debug']      			   = 'Debug Mode:<br /><span class="help">Saves send/recv data to the system log</span>';
//$_['entry_address']                = 'Address:<span class="help">Street/number</span>';
$_['entry_address']                = 'Address:';
//$_['entry_phone_number']           = 'Phone Number:<span class="help">Dial Code/Number</span>';
$_['entry_phone_number']           = 'Phone Number:';
$_['entry_number_of_items_per_package'] = 'Number of items per package<span class="help">Maximum number of items per package. The number of bulks delivered will be number of items purchased divided by this number</span>'; 
$_['entry_providers']              = 'Providers Selected For Results:<span class="help">Providers admitted for results</span>';
$_['entry_auto_ship_configuration']= 'Auto Ship Configuration<span class="help">Gestitrans Auto Ship VQMod is required to run this options. The Gestitrans VQMod makes possible to order automatically or by admin action the pickup of the package by the Gestitrans shipping method selected by the user</span>';
$_['entry_default_freigh']		   = 'Freight price';
$_['entry_free_shipping']		   = 'Enable free shipping<br/><span class="help">Free shipping when goods price exceeds a minimum amount</span>';
$_['entry_free_shipping_price_text1']		   = 'from';
$_['entry_free_shipping_price_text2']		   = 'euros';
$_['entry_fixed_shipping']		   = 'Enable fixed price shipping<br/><span class="help">Fixed shipping price to customers</span>';
$_['entry_fixed_shipping_price_text1']		   = 'euros';


// Error
$_['error_permission']             = 'Warning: You do not have permission to modify Gestitrans shipping!';
$_['error_username']               = 'Username Required!';
$_['error_password']               = 'Password Required!';
$_['error_username_password_invalid'] = 'Username or password to connect with gestitrans are incorrect';
$_['error_alternative_origin_address'] = 'If you choose to use an alternative origin address, you must enter it';
$_['error_city']                   = 'Origin City!';
$_['error_state']                  = 'Origin State/Province Required!';
$_['error_country']                = 'Origin Country Required!';
$_['error_dimension']              = 'Average Dimensions Required!';
$_['error_dimension_not_numeric']  = 'Average Dimensions not numeric';
$_['error_phone']                  = 'Phone Number Required!';
$_['error_phone_dialcode']         = 'Phone Number Dialcode Required!';
$_['error_zip']                    = 'Zip/Postal Code Required!';
$_['error_address']                = 'Address Required!';
$_['error_number_items_per_package'] = 'Number of items per package required!';
$_['error_one_provider_at_list_required'] = 'At least one provider must be checked!';
$_['error_use_alternative_name']   = 'If you choose to use an alternative name for the results, you must enter it';
$_['error_default_price_if_no_results_required'] = 'A valid numeric price must be given as default price';
$_['error_free_shipping_price'] = 'Free shipping amout required';
$_['error_free_shipping_price_not_numeric'] = 'Free shipping amout not numeric';
$_['error_fixed_shipping_price'] = 'Fixed shipping price amount required';
$_['error_fixed_shipping_price_not_numeric'] = 'Fixed shipping price amount not numeric';
$_['error_postalCode_invalid'] = 'Postal Code is incorrect in this origin country';
$_['error_postalCode_invalid'] = 'Origin city is incorrect in this origin country. Valid values: ';

// Infoenvia
$_['text_private_residence'] = 'Private residence';
$_['text_business_urban'] = 'Business urban';
$_['text_business_industrial'] = 'Business industrial';

$_['text_delay_for_shipping_same_day'] = 'Same day';
$_['text_delay_for_shipping_+1'] = 'Today +1';
$_['text_delay_for_shipping_+2'] = 'Today +2';
$_['text_delay_for_shipping_+3'] = 'Today +3';
$_['text_delay_for_shipping_+4'] = 'Today +4';

$_['text_ups'] = 'UPS';
$_['text_gls'] = 'GLS Euro Business';
$_['text_tourline'] = 'Tourline Express';
$_['text_fedex'] = 'FedEx';
$_['text_tnt'] = 'TNT';

$_['text_auto_ship_disabled'] = 'Disabled';
$_['text_auto_ship_enabled'] = 'Automatically on cart checkout';
$_['text_auto_ship_admin'] = 'Automatically by admin action';


// Gestitrans Placeholders
$_['text_lenght'] = 'lenght';
$_['text_width']  = 'width';
$_['text_height'] = 'height';
$_['text_items_per_package'] = 'items per package';
$_['text_username'] = 'username';
$_['text_password'] = 'password';
$_['text_choose_country'] = 'choose country';
$_['text_city'] = 'city';
$_['text_state'] = 'state/province';
$_['text_zip'] = 'zip/postal code';
$_['text_address'] = 'address';
$_['text_choose_country_dial_code'] = 'choose dial code';
$_['text_phone_number'] = 'phone number';

// Button
$_['button_ver_password']     = 'Show password';
$_['button_ocultar_password'] = 'Hide password';

?>
