<?php 
/**
 * Opencart Gestitrans Shipping Integration module.
 * 
 * Thanks to the wide network of transport companies who we work with, 
 * we can create a personalized proposal for your company, proposing the 
 * best transport company/ies for you to work with in order to optimize 
 * your shipping and reduce your cost.
 * 
 * You must take an agreement with www.gestitrans.com and get a username 
 * and a password from them to make possible to use theese shipping services.
 * 
 * *****************************************************************************
 * 
 * Gracias a la amplia red de empresas de transporte con las que trabajamos, 
 * podemos realizar un estudio personalizado para su empresa, proponiéndole la 
 * relación de empresas de transporte que optimicen sus envíos y abaraten sus 
 * costes.
 * 
 * Antes de empezar a utilizar los servicios de www.gestitrans.com, debe ponerse 
 * en contacto con gestitrans.com y recibir su nombre de usuario y contraseña 
 * para poder operar en el sistema.
 *  
 * @version 1.0
 * @copyright Garraiotech S.L. 2013
 * @author Ibermatica S.A., 2013
 *
 */
?>
<?php echo $header; ?>
<?php if(!isset($gestitrans_country_origin)){?>
<script type="text/javascript">
	
	$(document).ready(function(){
		hideAddressFields();
	});
		
	function toggleAddress(customAddress){
		if(customAddress == true){
			showAddressFields();
		}else{
			hideAddressFields();
		}
	}
	
	function hideAddressFields(){
		$(".addressFields").css("display","none");
		
	}
	
	function showAddressFields(){
		$(".addressFields").css("display","");
	}
</script>
<?php } ?>
<div id="content">
  <div class="breadcrumb">
    <?php foreach ($breadcrumbs as $breadcrumb) { ?>
    <?php echo $breadcrumb['separator']; ?><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a>
    <?php } ?>
  </div>
  <?php if ($error_warning) { ?>
  <div class="warning"><?php echo $error_warning; ?></div>
  <?php } ?>
  <div class="box">
    <div class="heading">
      <h1><img src="view/image/shipping.png" alt="" /> <?php echo $heading_title; ?></h1>
      <div class="buttons"><a onclick="$('#form').submit();" class="button"><?php echo $button_save; ?></a><a onclick="location = '<?php echo $cancel; ?>';" class="button"><?php echo $button_cancel; ?></a></div>
    </div>
    <div class="content">
      <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form">
        <table class="form">
          <tr>
          	<td colspan="2">
          		<div id="info" class="dashboard-content">
          			<div class="heading">
          				<h3><?php echo $info_gestitrans_heading; ?></h3>
          			</div>
          			<div class="content">
	          			<?php echo $info_gestitrans_body_1; ?>
	          			<br/><br/>
	          			<?php echo $info_gestitrans_body_2; ?>
	          			<br/><br/>
	          			<?php echo $info_gestitrans_body_3; ?>
	          		</div>
          		</div> 
          	</td>
          </tr>
          <tr>
            <td><span class="required">*</span> <?php echo $entry_username; ?></td>
            <td>
                <input type="text" name="gestitrans_username" value="<?php echo $gestitrans_username; ?>" placeholder="<?php echo $text_username?>" size="40"/>
                <?php if ($error_username) { ?>
                <span class="error"><?php echo $error_username; ?></span>
                <?php } ?>
            </td>
          </tr>
          <tr><!-- id="trPassword" style="display:none;"-->
            <td><span class="required">*</span> <?php echo $entry_password; ?></td>
            <td>
              <input type="password" name="gestitrans_password" id="gestitrans_password" value="<?php echo $gestitrans_password; ?>" placeholder="<?php echo $text_password?>" onKeyUp="$('#password_value').html(this.value)" size="40" />
              <span id="password_value" style="display:none;color:#FFFFFF; background: #D50000; padding: 4px 10px 4px 10px; border-radius:5px 5px 5px 5px;"><?php echo $gestitrans_password; ?></span>
              <span id="divOcultarPass" style="display:none;"><a onclick="$('#divVerPass').show();$('#divOcultarPass').hide();$('#password_value').hide();" class="button"><?php echo $button_ocultar_password; ?></a></span>
              <span id="divVerPass"><a onclick="$('#divVerPass').hide();$('#divOcultarPass').show();$('#password_value').show();" class="button"><?php echo $button_ver_password; ?></a></span>
              <?php if ($error_password) { ?>
              <span class="error"><?php echo $error_password; ?></span>
              <?php } ?>
            </td>
          </tr>
          <?php /*
          <tr>
            <td><span class="required"></span> <?php echo $entry_use_alternative_name; ?></td>
            <?php if($gestitrans_use_alternative_name==1){ ?>
            <td>
            	<input type="checkbox" name="gestitrans_use_alternative_name" value="1" checked="checked" onClick="if(this.checked){document.getElementById('gestitrans_alternative_name').disabled=false;}else{document.getElementById('gestitrans_alternative_name').disabled=true;}"/>
            	<input type="text" name="gestitrans_alternative_name" id="gestitrans_alternative_name" value="<?php echo $gestitrans_alternative_name; ?>" placeholder="<?php echo $heading_title?>" size="40"/>
            <?php }else{ ?>
            <td>
            	<input type="checkbox" name="gestitrans_use_alternative_name" value="1" onClick="if(this.checked){document.getElementById('gestitrans_alternative_name').disabled=false;}else{document.getElementById('gestitrans_alternative_name').disabled=true;}"/>
            	<input type="text" name="gestitrans_alternative_name" id="gestitrans_alternative_name" value="<?php echo $gestitrans_alternative_name; ?>" placeholder="<?php echo $heading_title?>" size="40" disabled/>
            <?php } ?>
              <?php if ($error_use_alternative_name) { ?>
              <span class="error"><?php echo $error_use_alternative_name; ?></span>
              <?php } ?></td>
          </tr>
          */ ?>
          <tr>
            <td><?php echo $entry_pickup; ?></td>
            <td><select name=gestitrans_pickup>
                <?php foreach ($delay_for_shipping as $pickup) { ?>
                <?php if ($pickup['value'] == $gestitrans_pickup) { ?>
                <option value="<?php echo $pickup['value']; ?>" selected="selected"><?php echo $pickup['text']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $pickup['value']; ?>"><?php echo $pickup['text']; ?></option>
                <?php } ?>
                <?php } ?>
              </select></td>
          </tr>
          <tr>
            <td><span class="required"></span> <?php echo $entry_alternative_origin_address; ?></td>
            <?php if($gestitrans_alternative_origin_address==1){ ?>
            <td>
				<?php if(!isset($gestitrans_country_origin)){?>
					<input type="checkbox" name="gestitrans_alternative_origin_address" value="1" checked="checked" onchange="javascript:toggleAddress(this.checked)"/>
				<?php }else{ ?>
					<input type="checkbox" name="gestitrans_alternative_origin_address" value="1" checked="checked" />
				<?php } ?>
			</td>
            <?php }else{ ?>
            <td>
				<?php if(!isset($gestitrans_country_origin)){?>
					<input type="checkbox" name="gestitrans_alternative_origin_address" value="1" onchange="javascript:toggleAddress(this.checked)"/>
				<?php }else{ ?>
					<input type="checkbox" name="gestitrans_alternative_origin_address" value="1" onchange="javascript:toggleAddress(this.checked)"/>
            		<?php } ?>
            <?php } ?>
              <?php if ($error_alternative_origin_address) { ?>
              <span class="error"><?php echo $error_alternative_origin_address; ?></span>
              <?php } ?></td>
          </tr>
          <?php /*if(isset($gestitrans_country_origin)){*/?>          
          <tr class="addressFields">
            <td>
              <span class="required">*</span>
              <?php echo $entry_country ?>
            </td>
            <td>
              <!--<input type="hidden" name="gestitrans_country_origin" value="<?php echo $gestitrans_country_origin; ?>" /-->
              <select name="gestitrans_country_origin">
                <option value="" selected="selected"><?php echo $text_choose_country?></option>
                <?php foreach ($gestitrans_origin_country as $origin_country) { ?>
                <?php if($origin_country["value"] == $gestitrans_country_origin){?>
                <option value="<?php echo $origin_country["value"]?>" selected="selected"><?php echo $origin_country["text"]?></option>
                <?php }else{?>
                <option value="<?php echo $origin_country["value"]?>"><?php echo $origin_country["text"]?></option>	
                <?php } ?>
                <?php } ?>
              </select>
              <?php if ($error_country) { ?>
              <span class="error"><?php echo $error_country; ?></span>
              <?php } ?></td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_city_origin)){*/?>
          <tr class="addressFields">
            <td>
              <span class="required">*</span>
              <?php echo $entry_city; ?>
            </td>
            <td>
              <input type="text" name="gestitrans_city_origin" value="<?php echo $gestitrans_city_origin; ?>" placeholder="<?php echo $text_city?>" size="40"/>
              <?php if ($error_city) { ?>
              <span class="error"><?php echo $error_city; ?></span>
              <?php } ?>
              <?php if ($error_city_invalid) { ?>
              <span class="error"><?php echo $error_city_invalid; ?></span>
              <?php } ?></td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_state_origin)){*/?>
          <tr class="addressFields">
            <td><?php echo $entry_state; ?></td>
            <td>
              <input type="text" name="gestitrans_state_origin" value="<?php echo $gestitrans_state_origin; ?>" placeholder="<?php echo $text_state?>"/>
              <?php if ($error_state) { ?>
              <span class="error"><?php echo $error_state; ?></span>
              <?php } ?></td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_zip_origin)){*/?>
          <tr class="addressFields">
            <td>
              <span class="required">*</span>
              <?php echo $entry_postcode; ?>
            </td>
            <td>
              <input type="text" name="gestitrans_zip_origin" value="<?php echo $gestitrans_zip_origin; ?>" placeholder="<?php echo $text_zip?>" size="10"/>
              <?php if ($error_zip) { ?>
              <span class="error"><?php echo $error_zip; ?></span>
              <?php } ?>
              <?php if ($error_postalCode_invalid) { ?>
              <span class="error"><?php echo $error_postalCode_invalid; ?></span>
              <?php } ?></td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_street_origin)){*/?>
          <tr class="addressFields">
            <td>
              <span class="required">*</span>
              <?php echo $entry_address; ?>
            </td>
            <td>
            	<input type="text" name="gestitrans_street_origin" value="<?php echo $gestitrans_street_origin; ?>" size="50" placeholder="<?php echo $text_address?>"/>
            	<?php if ($error_address) { ?>
	              <span class="error"><?php echo $error_address; ?></span>
	            <?php } ?></td>
            </td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_quote_type_name)){*/?>
          <tr class="addressFields">
            <td>
            	<span class="required">*</span>
            	<?php echo $entry_quote_type; ?>
            </td>
            <td>
              <input type="hidden" name="gestitrans_quote_type" value="<?php echo $gestitrans_quote_type; ?>"/>
              <select name="gestitrans_quote_type">
                <?php foreach ($gestitrans_quote_types as $quote_type) { ?>
                <?php if ($quote_type['value'] == $gestitrans_quote_type) { ?>
                <option value="<?php echo $quote_type['value']; ?>" selected="selected"><?php echo $quote_type['text']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $quote_type['value']; ?>"><?php echo $quote_type['text']; ?></option>
                <?php } ?>
                <?php } ?>
              </select>
            </td>
          </tr>
          <?php /*}*/ ?>
          <?php /*if(isset($gestitrans_phone_number)){*/?>
          <tr class="addressFields">
            <td>
              <span class="required">*</span>
              <?php echo $entry_phone_number; ?>
            </td>
            <td>
              	<input type="hidden" name="gestitrans_phone_dialcode" value="<?php echo $gestitrans_phone_dialcode; ?>" />
            	<select name="gestitrans_phone_dialcode">
            		<option value=""><?php echo $text_choose_country_dial_code?></option>
            	<?php foreach ($gestitrans_country_dialcode_list as $origin_dialCode) { ?>
                <?php if($origin_dialCode["value"] == $gestitrans_phone_dialcode){?>
                	<option value="<?php echo $origin_dialCode["value"]?>" selected="selected"><?php echo $origin_dialCode["text"]?></option>
                <?php }else{?>
                	<option value="<?php echo $origin_dialCode["value"]?>"><?php echo $origin_dialCode["text"]?></option>	
                <?php } ?>
                <?php } ?>
				</select> 
            	<input type="text" name="gestitrans_phone_number" value="<?php echo $gestitrans_phone_number; ?>" placeholder="<?php echo $text_phone_number?>" size="10"/>
            	<?php if ($error_phone) { ?>
	              <span class="error"><?php echo $error_phone; ?></span>
	            <?php } ?></td>
            </td>
          </tr>
          <?php /*}*/ ?>
          <tr>
            <td><?php echo $entry_display_weight; ?></td>
            <td><?php if ($gestitrans_display_weight) { ?>
              <input type="radio" name="gestitrans_display_weight" value="1" checked="checked" />
              <?php echo $text_yes; ?>
              <input type="radio" name="gestitrans_display_weight" value="0" />
              <?php echo $text_no; ?>
              <?php } else { ?>
              <input type="radio" name="gestitrans_display_weight" value="1" />
              <?php echo $text_yes; ?>
              <input type="radio" name="gestitrans_display_weight" value="0" checked="checked" />
              <?php echo $text_no; ?>
              <?php } ?></td>
          </tr>
          <tr>
            <td><?php echo $entry_weight_class; ?></td>
            <td><select name="gestitrans_weight_class_id" readonly>
                <?php foreach ($weight_classes as $weight_class) { ?>
                <?php /* if ($weight_class['weight_class_id'] == $gestitrans_weight_class_id) { ?>
                <option value="<?php echo $weight_class['weight_class_id']; ?>" selected="selected"><?php echo $weight_class['title']; ?></option>
                <?php } */?>
                <?php if ($weight_class['weight_class_id'] == $gestitrans_weight_class_id) { ?>
                <option value="<?php echo $weight_class['weight_class_id']; ?>" selected="selected"><?php echo $weight_class['title']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $weight_class['weight_class_id']; ?>"><?php echo $weight_class['title']; ?></option>
                <?php } ?>
                ?>
                <?php } ?>
              </select></td>
          </tr>
          <tr>
            <td><?php echo $entry_length_class; ?></td>
            <td><select name="gestitrans_length_class_id" readonly>
            	<?php foreach ($length_classes as $length_class) { ?>
                <?php if ($length_class['length_class_id'] == $gestitrans_length_class_id) { ?>
                <option value="<?php echo $length_class['length_class_id']; ?>" selected="selected"><?php echo $length_class['title']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $length_class['length_class_id']; ?>"><?php echo $length_class['title']; ?></option>
                <?php } ?>
                <?php }?>
              </select>
              </td>
          </tr>
          <tr>
            <td><span class="required"></span> <?php echo $entry_use_item_dimensions; ?></td>
            <?php if($gestitrans_use_item_dimensions==1){ ?>
            <td>
            	<input type="checkbox" name="gestitrans_use_item_dimensions" value="1" checked="checked"/>
            <?php }else{ ?>
            <td>
            	<input type="checkbox" name="gestitrans_use_item_dimensions" value="1" />
            <?php } ?>
              <?php if ($error_use_alternative_name) { ?>
              <span class="error"><?php echo $error_use_alternative_name; ?></span>
              <?php } ?></td>
          </tr>
          <tr>
            <td><span class="required">*</span> <?php echo $entry_dimension; ?></td>
            <td>            	
              <input type="text" name="gestitrans_length" id="gestitrans_length" value="<?php echo $gestitrans_length; ?>" size="4" placeholder="<?php echo $text_lenght?>"/>
              <input type="text" name="gestitrans_width" id="gestitrans_width" value="<?php echo $gestitrans_width; ?>" size="4"  placeholder="<?php echo $text_width?>"/>
              <input type="text" name="gestitrans_height" id="gestitrans_height" value="<?php echo $gestitrans_height; ?>" size="4"  placeholder="<?php echo $text_height?>"/>
              &nbsp;<?php echo $entry_length_for_dimensions; ?>
              <?php if ($error_dimension) { ?>
              <span class="error"><?php echo $error_dimension; ?></span>
              <?php } ?>
              <?php if ($error_dimension_not_numeric) { ?>
              <span class="error"><?php echo $error_dimension_not_numeric; ?></span>
              <?php } ?>
              </td>
          </tr>

          <?php /*
          <tr>
            <td><span class="required">*</span> <?php echo $entry_number_of_items_per_package; ?></td>
            <td>
            <input type="number" name="gestitrans_number_items_per_package" value="<?php echo $gestitrans_number_items_per_package; ?>" size="4" min="1" placeholder="<?php echo $text_items_per_package?>"/>
			  <?php if ($error_items_per_package) { ?>
              <span class="error"><?php echo $error_items_per_package; ?></span>
              <?php } ?></td>
          </tr>
          */ ?>
          
          <?php /*  
          <tr>
            <td><?php echo $entry_providers; ?></td>
            <td id="providers">
                <div class="scrollbox">
                  <div class="even">
                    <?php if ($gestitrans_ups_selected) { ?>
                    <input type="checkbox" name="gestitrans_ups_selected" value="1" checked="checked" />
                    <?php echo $text_ups; ?>
                    <?php } else { ?>
                    <input type="checkbox" name="gestitrans_ups_selected" value="1" />
                    <?php echo $text_ups; ?>
                    <?php } ?>
                  </div>
                  <div class="odd">
                    <?php if ($gestitrans_gls_selected) { ?>
                    <input type="checkbox" name="gestitrans_gls_selected" value="1" checked="checked" />
                    <?php echo $text_gls; ?>
                    <?php } else { ?>
                    <input type="checkbox" name="gestitrans_gls_selected" value="1" />
                    <?php echo $text_gls; ?>
                    <?php } ?>
                  </div>
                  <div class="even">
                    <?php if ($gestitrans_tourline_selected) { ?>
                    <input type="checkbox" name="gestitrans_tourline_selected" value="1" checked="checked" />
                    <?php echo $text_tourline; ?>
                    <?php } else { ?>
                    <input type="checkbox" name="gestitrans_tourline_selected" value="1" />
                    <?php echo $text_tourline; ?>
                    <?php } ?>
                  </div>
                  <div class="odd">
                    <?php if ($gestitrans_fedex_selected) { ?>
                    <input type="checkbox" name="gestitrans_fedex_selected" value="1" checked="checked" />
                    <?php echo $text_fedex; ?>
                    <?php } else { ?>
                    <input type="checkbox" name="gestitrans_fedex_selected" value="1" />
                    <?php echo $text_fedex; ?>
                    <?php } ?>
                  </div>
                  <div class="even">
                    <?php if ($gestitrans_tnt_selected) { ?>
                    <input type="checkbox" name="gestitrans_tnt_selected" value="1" checked="checked" />
                    <?php echo $text_tnt; ?>
                    <?php } else { ?>
                    <input type="checkbox" name="gestitrans_tnt_selected" value="1" />
                    <?php echo $text_tnt; ?>
                    <?php } ?>
                  </div>
               </div>
               <a onclick="$(this).parent().find(':checkbox').attr('checked', true);"><?php echo $text_select_all; ?></a> / <a onclick="$(this).parent().find(':checkbox').attr('checked', false);"><?php echo $text_unselect_all; ?></a>
               <?php if ($error_one_provider_at_least_required) { ?>
              <span class="error"><?php echo $error_one_provider_at_least_required; ?></span>
              <?php } ?>
            </td>
          </tr>
          */ ?>

          <?php if(isset($gestitrans_default_price_if_no_results)){?>
          <tr>
            <td><span class="required">*</span> <?php echo $entry_default_price_if_no_results; ?></td>
            <td>
            <?php echo $gestitrans_default_price_if_no_results; ?> <b>€</b>            
            <input type="hidden" name="gestitrans_default_price_if_no_results" value="<?php echo $gestitrans_default_price_if_no_results; ?>" /> 
            <?php if ($error_default_price_if_no_results) { ?>
              <span class="error"><?php echo $error_default_price_if_no_results; ?></span>
              <?php } ?></td>
          </tr>
		  <?php } ?>
		  
          <tr>
            <td><span class="required"></span> <?php echo $entry_free_shipping; ?></td>
            <?php if($gestitrans_free_shipping==1){ ?>
            <td>
            	<input type="checkbox" name="gestitrans_free_shipping" value="1" checked="checked"/>
            <?php }else{ ?>
            <td>
            	<input type="checkbox" name="gestitrans_free_shipping" value="1" />
            <?php } ?>
              
              <?php echo $entry_free_shipping_price_text1; ?>
              <input type="text" name="gestitrans_free_shipping_price" id="gestitrans_free_shipping_price" value="<?php echo $gestitrans_free_shipping_price; ?>" size="4" />
              <?php echo $entry_free_shipping_price_text2; ?>
              <?php if ($error_free_shipping_price) { ?>
              <span class="error"><?php echo $error_free_shipping_price; ?></span>
              <?php } ?>
              <?php if ($error_free_shipping_price_not_numeric) { ?>
              <span class="error"><?php echo $error_free_shipping_price_not_numeric; ?></span>
              <?php } ?>
            </td>
             
          </tr>
          
          <tr>
            <td><span class="required"></span> <?php echo $entry_fixed_shipping; ?></td>
            <?php if($gestitrans_fixed_shipping==1){ ?>
            <td>
            	<input type="checkbox" name="gestitrans_fixed_shipping" value="1" checked="checked"/>
            <?php }else{ ?>
            <td>
            	<input type="checkbox" name="gestitrans_fixed_shipping" value="1" />
            <?php } ?>
              <input type="text" name="gestitrans_fixed_shipping_price" id="gestitrans_fixed_shipping_price" value="<?php echo $gestitrans_fixed_shipping_price; ?>" size="4" />
              <?php echo $entry_fixed_shipping_price_text1; ?>
              <?php if ($error_fixed_shipping_price) { ?>
              <span class="error"><?php echo $error_fixed_shipping_price; ?></span>
              <?php } ?>
              <?php if ($error_fixed_shipping_price_not_numeric) { ?>
              <span class="error"><?php echo $error_fixed_shipping_price_not_numeric; ?></span>
              <?php } ?>
            </td>
             
          </tr>
          
          <tr>
            <td><?php echo $entry_geo_zone; ?></td>
            <td><select name="gestitrans_geo_zone_id">
                <option value="0"><?php echo $text_all_zones; ?></option>
                <?php foreach ($geo_zones as $geo_zone) { ?>
                <?php if ($geo_zone['geo_zone_id'] == $gestitrans_geo_zone_id) { ?>
                <option value="<?php echo $geo_zone['geo_zone_id']; ?>" selected="selected"><?php echo $geo_zone['name']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $geo_zone['geo_zone_id']; ?>"><?php echo $geo_zone['name']; ?></option>
                <?php } ?>
                <?php } ?>
              </select></td>
          </tr>

          
          <tr>
            <td><?php echo $entry_status; ?></td>
            <td><select name="gestitrans_status">
                <?php if ($gestitrans_status) { ?>
                <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                <option value="0"><?php echo $text_disabled; ?></option>
                <?php } else { ?>
                <option value="1"><?php echo $text_enabled; ?></option>
                <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                <?php } ?>
              </select>
              <input type="hidden" name="gestitrans_sort_order" value="1" size="1" />  
            </td>
          </tr>

          <?php /*
          <tr>
          	<td><?php echo $entry_auto_ship_configuration; ?></td>
            <td><select name="gestitrans_auto_ship_configuration">
                <?php foreach ($gestitrans_auto_ship_methods as $method) { ?>
                <?php if ($method['value'] == $gestitrans_auto_ship_configuration) { ?>
                <option value="<?php echo $method['value']; ?>" selected="selected"><?php echo $method['text']; ?></option>
                <?php } else { ?>
                <option value="<?php echo $method['value']; ?>"><?php echo $method['text']; ?></option>
                <?php } ?>
                <?php } ?>
              </select></td>
          </tr>
          */ ?>

          <?php /*
          Order se pone siempre a uno en el código fuente.
          <tr>
            <td><?php echo $entry_sort_order; ?></td>
            <td><input type="text" name="gestitrans_sort_order" value="<?php echo $gestitrans_sort_order; ?>" size="1" /></td>
          </tr>
          */ ?>

          <tr>
            <td><?php echo $entry_test; ?></td>
            <td><?php if ($gestitrans_test) { ?>
              <input type="radio" name="gestitrans_test" value="1" checked="checked" />
              <?php echo $text_yes; ?>
              <input type="radio" name="gestitrans_test" value="0" />
              <?php echo $text_no; ?>
              <?php } else { ?>
              <input type="radio" name="gestitrans_test" value="1" />
              <?php echo $text_yes; ?>
              <input type="radio" name="gestitrans_test" value="0" checked="checked" />
              <?php echo $text_no; ?>
              <?php } ?></td>
          </tr>
          
		  <tr>
            <td><?php echo $entry_debug; ?></td>
            <td><select name="gestitrans_debug">
              <?php if ($gestitrans_debug) { ?>
              <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
              <option value="0"><?php echo $text_disabled; ?></option>
              <?php } else { ?>
              <option value="1"><?php echo $text_enabled; ?></option>
              <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
              <?php } ?>
            </select></td>
          </tr>
          
          <tr>
            <td colspan="2">
            	<?php if ($gestitrans_terms_and_conds) { ?>
            		<input type="checkbox" name="gestitrans_terms_and_conds" id="gestitrans_terms_and_conds" value="1" checked />
            	<?php }else{?>
            		<input type="checkbox" name="gestitrans_terms_and_conds" id="gestitrans_terms_and_conds" value="1" />
            	<?php }?>
            	<?php echo $entry_terms_and_conds; ?>
            	<?php if ($error_gestitrans_terms_and_conds) { ?>
	              <span class="error"><?php echo $error_gestitrans_terms_and_conds; ?></span>
	            <?php } ?>
            </td>
          </tr>
          
        </table>
      </form>
    </div>
    <div class="heading" style="-webkit-border-radius: 0px 0px 7px 7px; border-radius: 0px 0px 7px 7px">
      <div class="buttons"><a onclick="$('#form').submit();" class="button"><?php echo $button_save; ?></a><a onclick="location = '<?php echo $cancel; ?>';" class="button"><?php echo $button_cancel; ?></a></div>
    </div>
  </div>
</div>

<?php echo $footer; ?>