<?php
/**
 * Opencart Gestitrans Shipping Integration module.
 * 
 * Thanks to the wide network of transport companies who we work with, 
 * we can create a personalized proposal for your company, proposing the 
 * best transport company/ies for you to work with in order to optimize 
 * your shipping and reduce your cost.
 * 
 * You must take an agreement with www.gestitrans.com and get a username 
 * and a password from them to make possible to use theese shipping services.
 * 
 * *****************************************************************************
 * 
 * Gracias a la amplia red de empresas de transporte con las que trabajamos, 
 * podemos realizar un estudio personalizado para su empresa, proponindole la 
 * relacin de empresas de transporte que optimicen sus envos y abaraten sus 
 * costes.
 * 
 * Antes de empezar a utilizar los servicios de www.gestitrans.com, debe ponerse 
 * en contacto con gestitrans.com y recibir su nombre de usuario y contrasea 
 * para poder operar en el sistema.
 *  
 * @version 1.0
 * @copyright Garraiotech S.L. 2013
 * @author Ibermatica S.A., 2013
 *
 */
class ModelShippingGestitrans extends Model {
	
	const CONTROLLER_CONTEXT_URI = "/service/rest/integration/search";
	
	const GESTITRANS_TEST_URL = "http://gestitrans.ibermatica.com";
	const GESTITRANS_PROD_URL = "https://www.gestitrans.com";
	
	function getQuote($address) {
		$this->load->language('shipping/gestitrans');
		$this->load->language('total/total');
		
		
		$method_data = array();
		
		$productList = $this->cart->getProducts();
		//print_r($productList);
		$weight = $this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $this->config->get('gestitrans_weight_class_id'));
		$productNumber = $this->cart->countProducts();
		$itemsPerBulk = $this->config->get('gestitrans_number_items_per_package');
		$bulkCount = ceil($productNumber/$itemsPerBulk);
		$length = $this->config->get('gestitrans_length');
		$width = $this->config->get('gestitrans_width');
		$height = $this->config->get('gestitrans_height');

		$weightClass = $this->config->get('gestitrans_weight_class_id');
		$lengthClass = $this->config->get('gestitrans_length_class_id');
		$weightClassString=$this->weight->getUnit($weightClass);
		$lengthClassString=$this->length->getUnit($lengthClass);
		
		if ($this->config->get('gestitrans_debug')) {
			$this->log->write("weightClass=".$weightClass);
			$this->log->write("weightClassString=".$weightClassString);
			$this->log->write("lengthClass=".$lengthClass);
			$this->log->write("lengthClassString=".$lengthClassString);
			$this->log->write("gestitrans_use_item_dimensions=".$this->config->get('gestitrans_use_item_dimensions'));
		}		
		
		$bulkList = "[";
		$itemCounter = 0;
		$totalItemCounter = 0;
		//$totalItems = count($productList); 
		// Total items
		$totalItems = 0;
		foreach ($productList as $product) {
			$totalItems += $product['quantity'];
		}
		$weightPerBulk = 0.0;
		$useItemDimensions = ($this->config->get('gestitrans_use_item_dimensions')==1);
		
		
		/// Tener en cuenta la cantidad de producto!!!!!
		if($useItemDimensions){
			foreach ($productList as $product){
				//print_r($product);
				for($count=0; $count<$product['quantity']; $count++){
					$this->log->write("productName=".$product['name']);
					if($product['length']>0 && $product['width']>0 && $product['height']>0){
						$itemLength = round($this->length->convert($product['length'],$product['length_class_id'],$lengthClass),0);
						$itemWidth  = round($this->length->convert($product['width'],$product['length_class_id'],$lengthClass),0);
						$itemHeight = round($this->length->convert($product['height'],$product['length_class_id'],$lengthClass),0);
						$itemWeight = $this->weight->convert(($product['weight']/$product['quantity']),$product['weight_class_id'],$weightClass);
						$this->log->write("itemLength=".$itemLength." itemWidth=".$itemWidth." itemHeight=".$itemHeight." itemWeight=".$itemWeight);
						if($bulkList!="[")
							$bulkList.=",";
						$bulkList.='["'.$itemLength.'","'.$itemWidth.'","'.$itemHeight.'","'.$itemWeight.'","1"]';
						$totalItemCounter++;
						$this->log->write("bulkAdded->Single Product With Own Dimensions: ".$product['name']);	
					}else{				
						//echo "(".$product["weight_class_id"]."==".$weightClass.")?".($product["weight_class_id"]==$weightClass);
						$weightPerBulk += $this->weight->convert(($product['weight']/$product['quantity']),$product["weight_class_id"],$weightClass);
						$itemCounter++;
						$totalItemCounter++;
						if($itemCounter == $itemsPerBulk || $totalItemCounter == $totalItems){
							if($bulkList!="[")
								$bulkList.=",";
							$bulkList.='["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
							//echo '["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
							$this->log->write("bulkAdded->Average package with: ".$itemCounter." products");
							$itemCounter=0;
							$weightPerBulk = 0.0;								
						}
					}					
				}
			}
			if($weightPerBulk > 0.0){
				// si pasa esto es que queda un elemento por aadir a la lista de bultos con medidas estandar:
				if($bulkList!="[")
					$bulkList.=",";
				$bulkList.='["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
				//echo '["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
				$this->log->write("bulkAdded (quedaba pendiente)->Average package with: ".$itemCounter." products");
				$itemCounter=0;
				$weightPerBulk = 0.0;
			}
		}else{
			foreach ($productList as $product){
				//print_r($product);
				for($count=0; $count<$product['quantity']; $count++){
					$this->log->write("productName=".$product['name']);
					//echo "(".$product["weight_class_id"]."==".$weightClass.")?".($product["weight_class_id"]==$weightClass);
					$weightPerBulk += $this->weight->convert($product["weight"],$product["weight_class_id"],$weightClass);
					$itemCounter++;
					$totalItemCounter++;
					if($itemCounter == $itemsPerBulk || $totalItemCounter == $totalItems){
						if($bulkList!="[")
							$bulkList.=",";
						$bulkList.='["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
						//echo '["'.$length.'","'.$width.'","'.$height.'","'.$weightPerBulk.'","1"]';
						$this->log->write("bulkAdded->Average package with: ".$itemCounter." products");
						$itemCounter=0;
						$weightPerBulk = 0.0;	
					}					
				}
			}
		}
		$bulkList.= "]";
		$this->log->write("bulkList: ".$bulkList);
		
		$todayDay = date("j", time());
		$todayMonth = date("n", time());
		$todayYear = date("Y", time()); 
		$pickUpDate = date("d-m-Y", mktime(0,0,0,$todayMonth, $todayDay + $this->config->get('gestitrans_pickup'), $todayYear));
		
		//Begin:Comentado por Agus. Para coger pais origen desde la bbdd
		$post = 
			"userName=".$this->config->get('gestitrans_username').
			"&password=".$this->config->get('gestitrans_password').
			"&pickUpDate=".$pickUpDate.
			"&countryFromFormat=gtech".
			"&countryFrom=".$this->config->get('gestitrans_country_origin').
			"&cpFrom=".$this->config->get('gestitrans_zip_origin').
			"&countryToFormat=iso2".
			"&countryTo=".$address['iso_code_2'].
			"&cpTo=".$address['postcode'].
			"&bulkList=".$bulkList.
			"&packaging=boxes_cardboard".
			"&stackable=true".
			"&shopType=opencart&shopName=".$this->config->get('config_name');
		/*$post = 
			"userName=".$this->config->get('gestitrans_username').
			"&password=".$this->config->get('gestitrans_password').
			"&pickUpDate=".$pickUpDate.
			"&countryToFormat=iso2".
			"&countryTo=".$address['iso_code_2'].
			"&cpTo=".$address['postcode'].
			"&bulkList=".$bulkList;*/
		//End:Comentado por Agus. Para coger pais origen desde la bbdd
		
		//echo $post;
		
		$url = ModelShippingGestitrans::GESTITRANS_PROD_URL;
		if($this->config->get('gestitrans_test')){
			$url = ModelShippingGestitrans::GESTITRANS_TEST_URL;	
		}
		$url = $url.ModelShippingGestitrans::CONTROLLER_CONTEXT_URI;
		$this->log->write("url: ".$url);
		
		$curl = curl_init($url);  
			
		curl_setopt($curl, CURLOPT_HEADER, 0);  
		curl_setopt($curl, CURLOPT_POST, 1);  
		curl_setopt($curl, CURLOPT_TIMEOUT, 60);  
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);  
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);  
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);  
		curl_setopt($curl, CURLOPT_POSTFIELDS, $post);  
		
		$results = curl_exec($curl);  

		$exito = false;
		
		if (empty($results)) {
			if ($this->config->get('gestitrans_debug')) {
				$this->log->write(ModelShippingGestitrans::CONTROLLER_CONTEXT_URI.': Resultado esta vacio');
			}
		} else {
			$info = curl_getinfo($curl);
			if (empty($info['http_code'])) {
				if ($this->config->get('gestitrans_debug')) {
					$this->log->write(ModelShippingGestitrans::CONTROLLER_CONTEXT_URI.': No se ha devuelto cdigo HTTP.');
				}
			} else {
				if ($info['http_code'] == '200'){
					$exito = true;
				}
				if ($this->config->get('gestitrans_debug')) {
					$this->log->write(ModelShippingGestitrans::CONTROLLER_CONTEXT_URI.': http_code: '.$info['http_code']);
				}
			}
		}

		curl_close($curl);
		
		if ($this->config->get('gestitrans_debug')) {
			$this->log->write("results: ".$results);
		}
		//print_r($results);
		//print_r($json);
		$textTitle = $this->language->get('text_title');
		if($this->config->get('gestitrans_use_alternative_name')){
			$textTitle = $this->config->get('gestitrans_alternative_name');
		}
			
		$infoenviaLogo = '<a href="https://www.infoenvia.com" target="_blank"><img src="http://infoenvia.ibermatica.com/images/infoenvia/infoenviaLittle.png" /></a>';
		
		$error = '';
		$rutaMasBarata = null;
		$precioMasBarato = null;
		if ($exito){
			$numberOfResults = 0;
			$json = json_decode($results);
			$isJson = false;
			$this->log->write("PHP_VERSION = ".phpversion());
			if (version_compare(PHP_VERSION, '5.3.0') >= 0) {
				if(json_last_error() == JSON_ERROR_NONE){
					$resultList = $json->results;
					$isJson = true;
				}else{
					$resultList = array();
				}
			}else{
				$resultList = $json->results;
			}
			$quote_data = array();
			foreach($resultList as $result){
				if(is_int($result->duration)){
					$theDuration = 24*$result->duration;
				}else{
					$explodedDuration = explode(",", $result->duration);
					$theDuration = "";
					foreach($explodedDuration as $singleDuration){
						if($theDuration != "")
							$theDuration.="-";
						$theDuration.=24*$singleDuration;
					}
				}
					
				$quote_data[$result->routeId] = array(
						'code'         => 'gestitrans.'.$result->routeId,
						'destino'      => $json->destino,
						'cpDestino'    => $json->cpDestino,
						'title'        => $result->providerName." ".$result->routeName." (".$theDuration." H)",
						'cost'         => $this->currency->convert($result->priceWithVAT, "EUR", $this->config->get('config_currency')),
						'tax_class_id' => "",
						'text'         => $this->currency->format($this->currency->convert($result->priceWithVAT, "EUR", $this->config->get('config_currency')))
				);
				if($this->config->get('gestitrans_test'))$this->log->write("result: ".$result->routeId."=".'gestitrans.'.$result->routeId);
				//Begin: Busco la ruta ms barata
				$precioActual = $this->currency->convert($result->priceWithVAT, "EUR", $this->config->get('config_currency'));
				if($precioMasBarato == null){ 
					$precioMasBarato = $precioActual; 
					$rutaMasBarata = $result->routeId;
				}
				if($precioMasBarato > $precioActual){
					$precioMasBarato = $precioActual;
					$rutaMasBarata = $result->routeId;
				}
				//End: Busco la ruta ms barata
				$numberOfResults++;
			}
				
			if($numberOfResults==0){
				$quote_data['gestitrans'] = array(
						'code'         => 'gestitrans.gestitrans',
						'title'        => $this->language->get('text_default_price_title'),//.$infoenviaLogo,
						'cost'         => $this->currency->convert($this->config->get('gestitrans_default_price_if_no_results'), "EUR", $this->config->get('config_currency')),
						'tax_class_id' => "",
						'text'         => $this->currency->format($this->currency->convert($this->config->get('gestitrans_default_price_if_no_results'), "EUR", $this->config->get('config_currency')))
				);
				//$numberOfResults++;
			}
				
			if(($isJson && $json->returnCode != '00') && $numberOfResults==0)
				$error = $json->returnCode." ".$json->returnMessage;
				
			if($json->returnCode == '01'){
				//Codigo de error de searchJson2.php, parmetros de entrada incompletos
				//De momento lo ponemos como que zip es invalido
				$error = $this->language->get('error_dest_zip_invalid');
			}
			if($json->returnCode == '03'){
				//Codigo de error de searchJson2.php, zip invalido
				$error = $this->language->get('error_dest_zip_invalid');
			}
			
			$this->log->write("result: ".$json->returnCode);
				
		}
		else{
			$error = $this->config->get('error_conexion');
			$quote_data['gestitrans'] = array(
					'code'         => 'gestitrans.gestitrans',
					'title'        => $this->language->get('text_default_price_title'),//.$infoenviaLogo,
					'cost'         => $this->currency->convert($this->config->get('gestitrans_default_price_if_no_results'), "EUR", $this->config->get('config_currency')),
					'tax_class_id' => "",
					'text'         => $this->currency->format($this->currency->convert($this->config->get('gestitrans_default_price_if_no_results'), "EUR", $this->config->get('config_currency')))
			);
		}
		
		// Begin: Si el check de precio del envio fijo est activado
		$fixedShipping = $this->config->get('gestitrans_fixed_shipping');
		$fixedShippingPrice = $this->config->get('gestitrans_fixed_shipping_price');
		if(!empty($fixedShipping) && !empty($fixedShippingPrice)){
			if(is_numeric($fixedShipping) && is_numeric($fixedShippingPrice)){
				$fixedShipping = intVal($fixedShipping);
				$fixedShippingPrice = $this->currency->convert($fixedShippingPrice, "EUR", $this->config->get('config_currency'));
				if (($fixedShipping == 1) && ($fixedShippingPrice > 0)){
					if($rutaMasBarata == null) $rutaMasBarata = 'gestitrans';
					unset($quote_data);
					$quote_data = array();
					$quote_data[$rutaMasBarata] = array(
							'code'         => 'gestitrans.'.$rutaMasBarata,
							'title'        => $this->language->get('text_fixed_price_title'),
							'cost'         => $this->currency->convert($fixedShippingPrice, "EUR", $this->config->get('config_currency')),
							'tax_class_id' => "",
							'text'         => $this->currency->format($this->currency->convert($fixedShippingPrice, "EUR", $this->config->get('config_currency')))
					);
				}
							}
		}
		// End: Si el check de precio del envio fijo est activado
		
		// Begin: Si el check de precio del envio gratis para una cantidad de dinero est activado
		$freeShipping = $this->config->get('gestitrans_free_shipping');
		$freeShippingPrice = $this->config->get('gestitrans_free_shipping_price');
		if(!empty($freeShipping) && !empty($freeShippingPrice)){
			if(is_numeric($freeShipping) && is_numeric($freeShippingPrice)){
				$freeShipping = intVal($freeShipping);
				$freeShippingPrice = $this->currency->convert($freeShippingPrice, "EUR", $this->config->get('config_currency'));
				$total = $this->cart->getTotal(); // Calculo el total del importe
				if (($freeShipping == 1) && ($freeShippingPrice <= $total)){
					if($rutaMasBarata == null) $rutaMasBarata = 'gestitrans';
					unset($quote_data);
					$quote_data = array();
					$quote_data[$rutaMasBarata] = array(
							'code'         => 'gestitrans.'.$rutaMasBarata,
							'title'        => $this->language->get('text_free_price_title'),
							'cost'         => $this->currency->convert("0", "EUR", $this->config->get('config_currency')),
							'tax_class_id' => "",
							'text'         => $this->currency->format($this->currency->convert("0", "EUR", $this->config->get('config_currency')))
					);
				}
							}
		}
		// End: Si el check de precio del envio gratis para una cantidad de dinero est activado
		
		$method_data = array(
			'code'       => 'gestitrans',
			'title'      => $textTitle.$infoenviaLogo,
			'quote'      => $quote_data,
			'sort_order' => $this->config->get('gestitrans_sort_order'),
			'error'      => utf8_encode($error)
		);
		
		//$this->session->data['shipping_method']['code'] = '';
		return $method_data;
		
		
	}
	
	function isJson($string) {
		json_decode($string);
		return (json_last_error() == JSON_ERROR_NONE);
	}
}
?>